#ifndef PhCnt_MainH
#define PhCnt_MainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>

#include <vcl\Registry.hpp>
#include <Buttons.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include <Grids.hpp>

#include "ThemeMgr.hpp"
#include "WakePort.h"
#include "FloatEdit.hpp"
#include <Graphics.hpp>

#define SOFTNAME "Meter"
#define ROUND(x) ((x > 0)? (x + 0.5) : (x - 0.5))

#define COLORS 7 //LEDs colors count

typedef struct //segment parameters
{
  int color;
  bool en;
  double dB;
  int code;
} led_t;

//---------------------------------------------------------------------------
//----------------------------- Meter thread: -------------------------------
//---------------------------------------------------------------------------

class TMeterThread : public TThread
{
private:
	TCriticalSection *cs;
  int FData[DATA_BUFF];       //meter data
  bool FStarted;              //started flag
protected:
  void __fastcall UpdateMeter(void);
	void __fastcall Execute();
public:
  __fastcall TMeterThread();
  __fastcall ~TMeterThread();
  void __fastcall SetStarted(bool s);
};

//---------------------------------------------------------------------------
//------------------------------ Main form: ---------------------------------
//---------------------------------------------------------------------------

class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TMainMenu *MainMenu;
  TMenuItem *mnFile;
  TMenuItem *mnExit;
  TMenuItem *mnDevice;
  TMenuItem *mnHelp;
  TMenuItem *mnAbout;
	TActionList *ActionList1;
  TAction *acExit;
  TAction *acAbout;
  TToolBar *ToolBar;
  TToolButton *tbSep1;
	TImageList *ImageList1;
  TOpenDialog *OpenDialog;
	TSaveDialog *SaveDialog;
	TTimer *Timer1;
  TStatusBar *StatusBar;
  TAction *acSettings;
  TToolButton *ToolButton3;
  TMenuItem *Settings1;
  TPanel *CtrlPanel;
  TPanel *BlockPanel;
  TAction *acConnect;
  TAction *acDisconnect;
  TMenuItem *Connect1;
  TMenuItem *Disconnect1;
  TMenuItem *N2;
  TToolButton *ToolButton1;
  TToolButton *ToolButton4;
  TToolButton *ToolButton5;
  TAction *acRead;
  TAction *acWrite;
  TToolButton *ToolButton6;
  TToolButton *ToolButton7;
  TMenuItem *ReadParams1;
  TMenuItem *WriteParams1;
  TMenuItem *N3;
  TToolButton *ToolButton8;
  TThemeManager *ThemeManager1;
  TAction *acPreOpen;
  TAction *acPreSave;
  TPanel *BarPanel;
  TPanel *TabPanel;
  TStringGrid *sgLogTable;
  TComboBox *cbPreset;
  TToolButton *ToolButton2;
  TToolButton *ToolButton9;
  TToolButton *ToolButton10;
  TPanel *Panel1A;
  TPanel *Panel2A;
  TPanel *IndPanel;
  TPanel *Panel4A;
  TPopupMenu *PopupMenu1;
  TMenuItem *Fill1;
  TMenuItem *Interpolate1;
  TAction *acFill;
  TAction *acInterpolate;
  TBitBtn *BitBtn1;
  TAction *acEeprom;
  TBitBtn *BitBtn2;
  TMenuItem *Table1;
  TMenuItem *Fill2;
  TMenuItem *Interpolate2;
  TToolButton *ToolButton11;
  TToolButton *ToolButton12;
  TMenuItem *N1;
  TMenuItem *SavetoEEPROM1;
  TCheckBox *cbLED0;
  TFloatEdit *feBrScale;
  TFloatEdit *feBrMeter;
  TComboBox *cbBrm;
  TCheckBox *cbLED1;
  TCheckBox *cbLED2;
  TCheckBox *cbLED3;
  TCheckBox *cbLED4;
  TCheckBox *cbLED5;
  TCheckBox *cbLED6;
  TCheckBox *cbLED7;
  TCheckBox *cbLED8;
  TCheckBox *cbLED9;
  TCheckBox *cbScale;
  TAction *acDefault;
  TMenuItem *OpenPreset1;
  TMenuItem *SaveParams2;
  TMenuItem *N5;
  TMenuItem *LoadDefaults1;
  TMenuItem *N4;
  TToolButton *ToolButton13;
  TToolButton *ToolButton14;
  TLabel *Label59;
  TLabel *Label60;
  TBitBtn *btReset;
  TCheckBox *cbStat;
  TPanel *Panel2B;
  TLabel *LabelM1;
  TLabel *LabelM2;
  TLabel *LabelM3;
  TLabel *LabelM4;
  TLabel *LabelM5;
  TLabel *LabelM6;
  TLabel *LabelM7;
  TLabel *LabelM8;
  TLabel *Label51;
  TLabel *Label52;
  TLabel *Label53;
  TLabel *Label54;
  TLabel *Label55;
  TLabel *Label56;
  TLabel *Label57;
  TLabel *Label58;
  TImage *Image1;
  TFloatEdit *feInteg1e;
  TFloatEdit *feResp1e;
  TFloatEdit *feDecay1e;
  TFloatEdit *feHold1e;
  TFloatEdit *feInteg2e;
  TFloatEdit *feResp2e;
  TFloatEdit *feDecay2e;
  TFloatEdit *feHold2e;
  TFloatEdit *feMHold1e;
  TFloatEdit *feMHold2e;
  TFloatEdit *feFall1e;
  TFloatEdit *feMFall1e;
  TFloatEdit *feScale1e;
  TFloatEdit *feScale2e;
  TFloatEdit *feFall2e;
  TFloatEdit *feMFall2e;
  TCheckBox *cbDispBar;
  TCheckBox *cbDispMaxBar;
  TCheckBox *cbDispPeak;
  TCheckBox *cbDispMaxPeak;
  TButton *btTest;
  TEdit *edTest;
  TPanel *Panel1B;
  TImage *Image3;
  TFloatEdit *feInteg1u;
  TFloatEdit *feInteg2u;
  TFloatEdit *feResp1u;
  TFloatEdit *feResp2u;
  TFloatEdit *feHold1u;
  TFloatEdit *feHold2u;
  TFloatEdit *feDecay1u;
  TFloatEdit *feDecay2u;
  TFloatEdit *feScale1u;
  TFloatEdit *feScale2u;
  TFloatEdit *feFall1u;
  TFloatEdit *feFall2u;
  TFloatEdit *feMHold1u;
  TFloatEdit *feMHold2u;
  TFloatEdit *feMFall1u;
  TFloatEdit *feMFall2u;
  TPanel *Panel4B;
  TShape *Shape1;
  TLabel *dBLabel1;
  TShape *Shape2;
  TShape *Shape3;
  TShape *Shape4;
  TShape *Shape5;
  TShape *Shape6;
  TShape *Shape7;
  TShape *Shape8;
  TShape *Shape9;
  TShape *Shape10;
  TShape *Shape11;
  TShape *Shape12;
  TShape *Shape13;
  TShape *Shape14;
  TShape *Shape15;
  TShape *Shape16;
  TShape *Shape17;
  TShape *Shape18;
  TShape *Shape19;
  TShape *Shape20;
  TShape *Shape21;
  TShape *Shape22;
  TShape *Shape23;
  TShape *Shape24;
  TShape *Shape25;
  TShape *Shape26;
  TShape *Shape27;
  TShape *Shape28;
  TShape *Shape29;
  TShape *Shape30;
  TShape *Shape31;
  TShape *Shape32;
  TShape *Shape33;
  TShape *Shape34;
  TShape *Shape35;
  TShape *Shape36;
  TShape *Shape37;
  TShape *Shape38;
  TShape *Shape39;
  TShape *Shape40;
  TShape *Shape41;
  TShape *Shape42;
  TShape *Shape43;
  TShape *Shape44;
  TShape *Shape45;
  TShape *Shape46;
  TShape *Shape47;
  TShape *Shape48;
  TShape *Shape49;
  TShape *Shape50;
  TShape *Shape51;
  TShape *Shape52;
  TShape *Shape53;
  TShape *Shape54;
  TShape *Shape55;
  TShape *Shape56;
  TShape *Shape57;
  TShape *Shape58;
  TShape *Shape59;
  TShape *Shape60;
  TShape *Shape61;
  TShape *Shape62;
  TShape *Shape63;
  TShape *Shape64;
  TShape *Shape65;
  TShape *Shape66;
  TShape *Shape67;
  TShape *Shape68;
  TShape *Shape69;
  TShape *Shape70;
  TShape *Shape71;
  TShape *Shape72;
  TShape *Shape73;
  TShape *Shape74;
  TShape *Shape75;
  TShape *Shape76;
  TShape *Shape77;
  TShape *Shape78;
  TShape *Shape79;
  TShape *Shape80;
  TShape *Shape81;
  TShape *Shape82;
  TShape *Shape83;
  TShape *Shape84;
  TShape *Shape85;
  TShape *Shape86;
  TShape *Shape87;
  TShape *Shape88;
  TShape *Shape89;
  TShape *Shape90;
  TShape *Shape91;
  TShape *Shape92;
  TShape *Shape93;
  TShape *Shape94;
  TShape *Shape95;
  TShape *Shape96;
  TShape *Shape97;
  TShape *Shape98;
  TShape *Shape99;
  TShape *Shape100;
  TLabel *dBLabel2;
  TLabel *dBLabel3;
  TLabel *dBLabel4;
  TLabel *dBLabel5;
  TLabel *dBLabel6;
  TLabel *dBLabel7;
  TLabel *dBLabel8;
  TLabel *dBLabel9;
  TLabel *dBLabel10;
  TLabel *dBLabel11;
  TLabel *dBLabel12;
  TLabel *dBLabel13;
  TLabel *dBLabel14;
  TLabel *dBLabel15;
  TLabel *dBLabel16;
  TLabel *dBLabel17;
  TLabel *dBLabel18;
  TLabel *dBLabel19;
  TLabel *dBLabel20;
  TLabel *dBLabel21;
  TLabel *dBLabel22;
  TLabel *dBLabel23;
  TLabel *dBLabel24;
  TLabel *dBLabel25;
  TLabel *dBLabel26;
  TLabel *dBLabel27;
  TLabel *dBLabel28;
  TLabel *dBLabel29;
  TLabel *dBLabel30;
  TLabel *dBLabel31;
  TLabel *dBLabel32;
  TLabel *dBLabel33;
  TLabel *dBLabel34;
  TLabel *dBLabel35;
  TLabel *dBLabel36;
  TLabel *dBLabel37;
  TLabel *dBLabel38;
  TLabel *dBLabel39;
  TLabel *dBLabel40;
  TLabel *dBLabel41;
  TLabel *dBLabel42;
  TLabel *dBLabel43;
  TLabel *dBLabel44;
  TLabel *dBLabel45;
  TLabel *dBLabel46;
  TLabel *dBLabel47;
  TLabel *dBLabel48;
  TLabel *dBLabel49;
  TLabel *dBLabel50;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall acExitExecute(TObject *Sender);
  void __fastcall acAboutExecute(TObject *Sender);
  void __fastcall acSettingsExecute(TObject *Sender);
  void __fastcall acConnectExecute(TObject *Sender);
  void __fastcall acDisconnectExecute(TObject *Sender);
  void __fastcall acReadExecute(TObject *Sender);
  void __fastcall acWriteExecute(TObject *Sender);
  void __fastcall acPreOpenExecute(TObject *Sender);
  void __fastcall acPreSaveExecute(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall feInteg1eChanged(TObject *Sender);
  void __fastcall sgLogTableDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall acFillExecute(TObject *Sender);
  void __fastcall acInterpolateExecute(TObject *Sender);
  void __fastcall sgLogTableKeyPress(TObject *Sender, char &Key);
  void __fastcall sgLogTableDblClick(TObject *Sender);
  void __fastcall acEepromExecute(TObject *Sender);
  void __fastcall acDefaultExecute(TObject *Sender);
  void __fastcall cbLED0Click(TObject *Sender);
  void __fastcall cbPresetChange(TObject *Sender);
  void __fastcall cbDispBarClick(TObject *Sender);
  void __fastcall btResetClick(TObject *Sender);
  void __fastcall feInteg1uChanged(TObject *Sender);
  void __fastcall btTestClick(TObject *Sender);
private:	// User declarations
  bool Lock;                  //controls events disable flag
  int FPortNumber;            //port number
  AnsiString FPortName;       //port name
  AnsiString FDeviceName;     //device name
  AnsiString FDataDir;        //path to save data files
  AnsiString FFileName;       //data file name
  bool FModified;             //data modification flag
  void __fastcall Connect(void);    //meter connect
  void __fastcall Disconnect(void); //meter disconnect
	void __fastcall ReadConfig(void); //read config
	void __fastcall SaveConfig(void); //save config
  TMeterThread *MeterThread;  //bars updatr thread
  void __fastcall SetSegsCount(void); //set bars length
  void __fastcall ClearMeter(void); //bars clear
  int FPreset;                //current preset number
  int FDispMode;              //current display mode
  int FLedsSet;               //current LEDs set
  int BarL, BarR;             //measured data...
  int PeakL, PeakR;
  int BarMaxL, BarMaxR;
  int PeakMaxL, PeakMaxR;
  double __fastcall Code2dB(int code); //convert code to dB
  void __fastcall DispStatus(void); //display dB in status bar
  void __fastcall ClearStatus(void); //clear status bar
  void __fastcall WriteTable(void); //write table to the meter

public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);
  TWakePort *WakePort;        //port object
  bool FConnected;            //connection flag
  bool FAutoConnect;          //auto connect flag
  bool FAutoLoad;             //auto parameters load flag
  int FSample;                //sample period
  int FSegs;                  //segments count
  TColor Colors[COLORS];      //colors array
  led_t Leds[SEGS];           //LEDs params array
  TComponentList *Labels;     //segments names list
  TComponentList *LedsL;      //segments list L
  TComponentList *LedsR;      //segments list R
  void __fastcall FillLists(void); //lists fill
  void __fastcall FillTable(void); //table fill
  void __fastcall DrawScale(void); //draw scale
  int NewColor, NewEn;        //segment new params
  double NewdB;               //segment new level
  int FRow, FRowE;            //current selected rows
  void __fastcall UpdateMeter(int *v); //bars update
};

//---------------------------------------------------------------------------

extern PACKAGE TMainForm *MainForm;

//---------------------------------------------------------------------------

#endif
