#ifndef WakePortH
#define WakePortH

#include "WakeCom.h"
#include "Defs.h"

#define DEVICE_NAME "Meter" //device name
#define BAUD_RATE   115200  //baud rate

//----------------------------------------------------------------------------
//------------------------ Special command codes: ----------------------------
//----------------------------------------------------------------------------

enum WakeScmd_t
{
  CMD_STD_LAST = CMD_GETADDR,

  CMD_SET_PRESET, //set preset number
  CMD_GET_PRESET, //get preset number
  CMD_SET_MODE,   //set display mode
  CMD_GET_MODE,   //get display mode
  CMD_GET_METER,  //get measured data
  CMD_RES_STAT,   //statistics reset
  CMD_SET_PARAMS, //set parameters
  CMD_GET_PARAMS, //get parameters
  CMD_SET_TABLE,  //load table
  CMD_GET_TABLE,  //read table
  CMD_SET_LEDS,   //LEDs control
  CMD_GET_LEDS,   //read LEDs state
  CMD_EE_SAVE,    //save parameters to EEPROM
  CMD_DEFAULT,    //load defaults
  CMD_TEST
};

//----------------------------------------------------------------------------
//------------------------- WAKE serial port class: --------------------------
//----------------------------------------------------------------------------

class TWakePort : public TWakeCom
{
private:

protected:

public:
  __fastcall TWakePort();
  __fastcall ~TWakePort();
  void __fastcall SetPreset(int p);
  void __fastcall GetPreset(int &p);
  void __fastcall SetDispMode(int m);
  void __fastcall GetDispMode(int &m);
  void __fastcall GetMeter(int *v);
  void __fastcall ResetStat(void);
  void __fastcall SetParams(params_t p1, params_t p2);
  void __fastcall GetParams(params_t &p1, params_t &p2);
  void __fastcall SetTable(int *t);
  void __fastcall GetTable(int *t);
  void __fastcall SetLeds(int m, int bm, int bs, int n);
  void __fastcall GetLeds(int &m, int &bm, int &bs, int &n);
  void __fastcall EESave(void);
  void __fastcall Default(void);
  void __fastcall Test(uint32_t &t);
};

//---------------------------------------------------------------------------

#endif
